library IsmAvatar;

uses mmsystem;

function _set_wav(left,right : real) : real; stdcall;
var
  woc : WaveOutCaps;
begin
  if waveOutGetDevCaps(wave_mapper,@woc,sizeof(woc))=mmsyserr_noerror then
    waveOutSetVolume(wave_mapper,trunc(right)*65536+trunc(left));
  _set_wav := 1;
end;

function _get_wavl() : real; stdcall;
var
  woc : WaveOutCaps;
  vol : DWord;
begin
  if waveOutGetDevCaps(wave_mapper,@woc,sizeof(woc))=mmsyserr_noerror then
    waveOutGetVolume(wave_mapper,@vol);
  _get_wavl := real(vol mod 65536);
end;

function _get_wavr() : real; stdcall;
var
  woc : WaveOutCaps;
  vol : DWord;
begin
  if waveOutGetDevCaps(wave_mapper,@woc,sizeof(woc))=mmsyserr_noerror then
    waveOutGetVolume(wave_mapper,@vol);
  _get_wavr := real(vol div 65536);
end;

function _set_mid(left,right : real) : real; stdcall;
var
  moc : MidiOutCaps;
begin
  if midiOutGetDevCaps(midi_mapper,@moc,sizeof(moc))=mmsyserr_noerror then
    midiOutSetVolume(midi_mapper,trunc(right)*65536+trunc(left));
  _set_mid := 1;
end;

function _get_midl() : real; stdcall;
var
  moc : MidiOutCaps;
  vol : DWord;
begin
  if midiOutGetDevCaps(midi_mapper,@moc,sizeof(moc))=mmsyserr_noerror then
    midiOutGetVolume(midi_mapper,@vol);
  _get_midl := real(vol mod 65536);
end;

function _get_midr() : real; stdcall;
var
  moc : MidiOutCaps;
  vol : DWord;
begin
  if midiOutGetDevCaps(midi_mapper,@moc,sizeof(moc))=mmsyserr_noerror then
    midiOutGetVolume(midi_mapper,@vol);
  _get_midr := real(vol div 65536);
end;

function _set_aux(left,right : real) : real; stdcall;
var
  ac : AuxCaps;
begin
  if auxGetDevCaps(aux_mapper,@ac,sizeof(ac))=mmsyserr_noerror then
    auxSetVolume(aux_mapper,trunc(right)*65536+trunc(left));
  _set_aux := 1;
end;

function _get_auxl() : real; stdcall;
var
  ac : AuxCaps;
  vol : DWord;
begin
  if auxGetDevCaps(aux_mapper,@ac,sizeof(ac))=mmsyserr_noerror then
    auxGetVolume(aux_mapper,@vol);
  _get_auxl := real(vol mod 65536);
end;

function _get_auxr() : real; stdcall;
var
  ac : AuxCaps;
  vol : DWord;
begin
  if auxGetDevCaps(aux_mapper,@ac,sizeof(ac))=mmsyserr_noerror then
    auxGetVolume(aux_mapper,@vol);
  _get_auxr := real(vol div 65536);
end;

exports _set_wav, _get_wavl, _get_wavr;
exports _set_mid, _get_midl, _get_midr;
exports _set_aux, _get_auxl, _get_auxr;

begin end.
